function cmc_aver = GetCmcFromFeedback(rerank_history, nfold_idx, ngallery, stat_idx)

if ~strcmp(class(rerank_history), 'cell')
    rh_t = cell(1,1);
    rh_t{1} = rerank_history;
    rerank_history = rh_t;
    clear rh_t;
end
%
nfold = length(nfold_idx);
nfeedback = size(rerank_history{1}, 2);
cmc_nfold = cell(1, nfold);
cmc_aver = zeros(nfeedback, ngallery);

% for nf = 1:nfold
%     rerank_h_t = rerank_history{nfold_idx(nf)};
%     rerank_h_t = rerank_h_t(stat_idx{nfold_idx(nf)},:)
%     
%     cmc_nfold{nf} = zeros(nfeedback, ngallery);
%     for i = 1:nfeedback
%         for j = 1:ngallery
%             cmc_nfold{nf}(i,j) = length(find(rerank_h_t(:,i)<=j));
%         end
%     end
%     
%     cmc_nfold{nf} = cmc_nfold{nf} / length(stat_idx{nfold_idx(nf)});
%     
%     cmc_aver = cmc_aver + cmc_nfold{nf};
% end
% cmc_aver = cmc_aver / nfold;


%% method 2 for statistics

for nf = 1:nfold
    rerank_h_t = rerank_history{nfold_idx(nf)};
    rerank_h_t = rerank_h_t(stat_idx{nfold_idx(nf)},:);
    
    cmc_nfold{nf} = zeros(nfeedback, ngallery);
    for i = 1:nfeedback
        for j = 1:ngallery
            cmc_nfold{nf}(i,j) = length(find(rerank_h_t(:,i)<=j));
        end
    end    
end

% for each feedback
for i = 1:nfeedback
    % for each fold
    for nf = 1:nfold
        cmc_aver(i,:) = cmc_aver(i,:) + cmc_nfold{nf}(i,:);
    end
end

% how many samples
numSampTotal = 0;
for nf = 1:nfold
    numSampTotal = numSampTotal + length(stat_idx{nfold_idx(nf)});
end

cmc_aver = cmc_aver / numSampTotal;

