% plot ilidsviper
%
rand('state', 3);
close all
clrs = rand(20,3);                % ɫ
clrs = [clrs; [1,0,0]];
msize = 15;                      % marker size
lwidth = 5;                      % 

%% public parameters
nTopShow = 0;
NP = 119;
nfold_idx = [1:10];

%% -------------------------------------------------------------------------------
%% ----- ---------------------------------------------(one click)
showorder = [1:30];
nIter = 1;
nTopShow = 0;

% our - nomanifold
matname = sprintf('./one-click/rerank_l1_%d_nomanifold_oneclick.mat', NP);
load(matname);
rerank_nomanifold_l1_one_click = rerank_history;

% our - no visual expansion
matname = sprintf('./one-click/rerank_l1_%d_RF_Afflapsvm_nomapped.mat', NP);
load(matname);
rerank_cf_nomapped_l1_one_click = rerank_history;


% l1 - cf
matname = sprintf('./one-click/rerank_l1_%d_RF_AfflapSVM_oneclick.mat', NP);
load(matname);
rerank_cf_l1_one_click = rerank_history;

% l1 - Eu
matname = sprintf('./one-click/rerank_l1_%d_eu-selftune_AfflapSVM_oneclick.mat', NP);
load(matname);
rerank_eu_l1_one_click = rerank_history;


% prdc + cf
matname = sprintf('./one-click/rerank_prdc_%d_RF_AfflapSVM_oneclick.mat', NP);
load(matname);
rerank_prdc_one_click = rerank_history;

% ranksvm + cf
matname = sprintf('./one-click/rerank_ranksvm_%d_RF_AfflapSVM_oneclick.mat', NP);
load(matname);
rerank_ranksvm_one_click  = rerank_history;

% mcc + cf
matname = sprintf('./one-click/rerank_mcc_%d_RF_AfflapSVM_oneclick.mat', NP);
load(matname);
rerank_mcc_one_click  = rerank_history;

% other method 

% naive
matname = sprintf('./one-click/rerank_naive_l1_%d_one_click.mat', NP);
load(matname);
rerank_naive_l1_one_click = rerank_naive;

% prf
matname = sprintf('./one-click/rerank_l1_%d_topbottom_prf.mat', NP);
load(matname);
rerank_prf_one_click = rerank_history;

% nprf
matname = sprintf('./one-click/rerank_l1_%d_topbottom_nprf.mat', NP);
load(matname);
rerank_nprf_one_click = rerank_history;

% emr
matname = sprintf('./one-click/rerank_l1_%d_weakstrong_emr.mat', NP);
load(matname);
rerank_emr_one_click = rerank_history;


%
stat_idx_l1 = cell(1, size(rerank_naive_l1_one_click, 2));
for nf = 1:size(rerank_naive_l1_one_click, 2)
    stat_idx_l1{nf} = find(rerank_naive_l1_one_click{nf}(:,1) > nTopShow);
end
cmc_naive_l1_one_click   = getCmcFromFeedback(rerank_naive_l1_one_click, nfold_idx, NP, stat_idx_l1);
cmc_nprf_one_click   = getCmcFromFeedback(rerank_nprf_one_click, nfold_idx, NP, stat_idx_l1);
cmc_prf_one_click   = getCmcFromFeedback(rerank_prf_one_click, nfold_idx, NP, stat_idx_l1);
cmc_emr_one_click   = getCmcFromFeedback(rerank_emr_one_click, nfold_idx, NP, stat_idx_l1);
cmc_nove_l1_one_click   = getCmcFromFeedback(rerank_cf_nomapped_l1_one_click, nfold_idx, NP, stat_idx_l1);

% 
stat_idx_nomanifold = cell(1, size(rerank_nomanifold_l1_one_click, 2));
for nf = 1:size(rerank_nomanifold_l1_one_click, 2)
    stat_idx_nomanifold{nf} = find(rerank_nomanifold_l1_one_click{nf}(:,1) > nTopShow);
end
cmc_nomanifold_l1_one_click   = getCmcFromFeedback(rerank_nomanifold_l1_one_click, nfold_idx, NP, stat_idx_nomanifold);


stat_idx_l1 = cell(1, size(rerank_cf_l1_one_click, 2));
for nf = 1:size(rerank_cf_l1_one_click, 2)
    stat_idx_l1{nf} = find(rerank_cf_l1_one_click{nf}(:,1) > nTopShow);
end
cmc_cf_l1_one_click = getCmcFromFeedback(rerank_cf_l1_one_click, nfold_idx, NP, stat_idx_l1);

stat_idx_l1_eu = cell(1, size(rerank_eu_l1_one_click, 2));
for nf = 1:size(rerank_eu_l1_one_click, 2)
    stat_idx_l1_eu{nf} = find(rerank_eu_l1_one_click{nf}(:,1) > nTopShow);
end
cmc_eu_l1_one_click   = getCmcFromFeedback(rerank_eu_l1_one_click, nfold_idx, NP, stat_idx_l1_eu);

% ranksvm
stat_idx_ranksvm = cell(1, size(rerank_ranksvm_one_click, 2));
for nf = 1:size(rerank_ranksvm_one_click, 2)
    stat_idx_ranksvm{nf} = find(rerank_ranksvm_one_click{nf}(:,1) > nTopShow);
end
cmc_ranksvm_one_click   = getCmcFromFeedback(rerank_ranksvm_one_click, nfold_idx, NP, stat_idx_ranksvm);

% prdc
stat_idx_prdc = cell(1, size(rerank_prdc_one_click, 2));
for nf = 1:size(rerank_prdc_one_click, 2)
    stat_idx_prdc{nf} = find(rerank_prdc_one_click{nf}(:,1) > nTopShow);
end
cmc_prdc_one_click   = getCmcFromFeedback(rerank_prdc_one_click, nfold_idx, NP, stat_idx_prdc);

% mcc
stat_idx_mcc = cell(1, size(rerank_mcc_one_click, 2));
for nf = 1:size(rerank_mcc_one_click, 2)
    stat_idx_mcc{nf} = find(rerank_mcc_one_click{nf}(:,1) > nTopShow);
end
cmc_mcc_one_click   = getCmcFromFeedback(rerank_mcc_one_click, nfold_idx, NP, stat_idx_mcc);

%% one-click : compare with other methods
msize = 15;                      % marker size
lwidth = 5;                      % 
figure, hold on
showorder = 5;
% naive
plot(cmc_naive_l1_one_click(:, showorder), 'Color', clrs(1,:), 'LineStyle', '-', 'LineWidth', lwidth);
% SVM
plot(cmc_nomanifold_l1_one_click(:,showorder), 'Color', clrs(6,:), 'LineStyle', '-', 'Marker', 'd', 'MarkerSize', msize, 'LineWidth', lwidth);
% nprf
plot(cmc_nprf_one_click(:,showorder), 'Color', clrs(2,:), 'LineStyle', '-', 'Marker', '<', 'MarkerSize', msize, 'LineWidth', lwidth);
% prf
plot(cmc_prf_one_click(:,showorder), 'Color', clrs(3,:), 'LineStyle', '-', 'Marker', '>', 'MarkerSize', msize, 'LineWidth', lwidth);
% emr
plot(cmc_emr_one_click(:,showorder), 'Color', clrs(5,:), 'LineStyle', '-', 'Marker', '+', 'MarkerSize', msize, 'LineWidth', lwidth);
% our
plot(cmc_cf_l1_one_click(:,showorder), 'Color', clrs(end,:), 'LineStyle', '-', 'Marker', 's', 'MarkerSize', msize, 'LineWidth', lwidth);

legend('Naive', 'SVM', 'NPRF', 'PRF', 'EMR', 'POP');

box on;
grid on;
titleName = sprintf('(one)Matching rate in Top %d (iLIDs)', showorder);
title(titleName, 'fontsize', 30);
xlabel('round of feedback', 'fontsize', 30); ylabel('Recognition rate', 'fontsize', 30);
%set(gca,'xtick', 0:size(cmc_cf_lapsvm, 1)-1);

%% one-click: with or without visual expansion
figure, hold on
showorder = 5;

plot(cmc_nove_l1_one_click(:,showorder), 'Color', clrs(10,:), 'LineStyle', '-', 'Marker', 's', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_cf_l1_one_click(:,showorder), 'Color', clrs(7,:), 'LineStyle', '-', 'Marker', 'd', 'MarkerSize', msize, 'LineWidth', lwidth);

legend('Without Visual Expansion', 'With Visual Expansion');

box on;
grid on;
titleName = sprintf('Matching rate in Top %d (iLIDs)', showorder);
title(titleName, 'fontsize', 30);
xlabel('round of feedback', 'fontsize', 30); ylabel('Recognition rate', 'fontsize', 30);

%% one -click combination with re-id methods
showorder = [1:30];
nIter = 1;
nTopShow = 0;
lwidth = 3;
msize = 10;

% % (1) initialized by L1
figure, hold
plot(cmc_cf_l1_one_click(1,showorder), 'Color', clrs(1,:), 'LineStyle', '--', 'LineWidth', lwidth);
plot(cmc_cf_l1_one_click(2,showorder), 'Color', clrs(6,:), 'LineStyle', '-', 'Marker', 'o', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_cf_l1_one_click(3,showorder), 'Color', clrs(7,:), 'LineStyle', '-', 'Marker', '+', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_cf_l1_one_click(4,showorder), 'Color', clrs(8,:), 'LineStyle', '-', 'Marker', 's', 'MarkerSize', msize, 'LineWidth', lwidth);

legend('L1-Norm', 'Iteration 1', 'Iteration 2', 'Iteration 3');

box on;
grid on;
titleName = sprintf('iLIDs(one click)');
title(titleName, 'fontsize', 30);
xlabel('CMC order', 'fontsize', 30); ylabel('Recognition rate', 'fontsize', 30);
xlim([1, showorder(end)]);

% (2) initialized by ranksvm
figure, hold
plot(cmc_ranksvm_one_click(1,showorder), 'Color', clrs(1,:), 'LineStyle', '--', 'LineWidth', lwidth);
plot(cmc_ranksvm_one_click(2,showorder), 'Color', clrs(6,:), 'LineStyle', '-', 'Marker', 'o', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_ranksvm_one_click(3,showorder), 'Color', clrs(7,:), 'LineStyle', '-', 'Marker', '+', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_ranksvm_one_click(4,showorder), 'Color', clrs(8,:), 'LineStyle', '-', 'Marker', 's', 'MarkerSize', msize, 'LineWidth', lwidth);

legend('RankSVM', 'Iteration 1', 'Iteration 2', 'Iteration 3');

box on;
grid on;
titleName = sprintf('iLIDs(one click)');
title(titleName, 'fontsize', 30);
xlabel('CMC order', 'fontsize', 30); ylabel('Recognition rate', 'fontsize', 30);
xlim([1, showorder(end)]);
hold off

% % (3) initialized by prdc
figure, hold
plot(cmc_prdc_one_click(1,showorder), 'Color', clrs(1,:), 'LineStyle', '--', 'LineWidth', lwidth);
plot(cmc_prdc_one_click(2,showorder), 'Color', clrs(6,:), 'LineStyle', '-', 'Marker', 'o', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_prdc_one_click(3,showorder), 'Color', clrs(7,:), 'LineStyle', '-', 'Marker', '+', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_prdc_one_click(4,showorder), 'Color', clrs(8,:), 'LineStyle', '-', 'Marker', 's', 'MarkerSize', msize, 'LineWidth', lwidth);

legend('PRDC', 'Iteration 1', 'Iteration 2', 'Iteration 3');

box on;
grid on;
titleName = sprintf('iLIDs(one click)');
title(titleName, 'fontsize', 30);
xlabel('CMC order', 'fontsize', 30); ylabel('Recognition rate', 'fontsize', 30);
xlim([1, showorder(end)]);
hold off

% % (4) initialized by mcc
figure, hold
plot(cmc_mcc_one_click(1,showorder), 'Color', clrs(1,:), 'LineStyle', '--', 'LineWidth', lwidth);
plot(cmc_mcc_one_click(2,showorder), 'Color', clrs(6,:), 'LineStyle', '-', 'Marker', 'o', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_mcc_one_click(3,showorder), 'Color', clrs(7,:), 'LineStyle', '-', 'Marker', '+', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_mcc_one_click(4,showorder), 'Color', clrs(8,:), 'LineStyle', '-', 'Marker', 's', 'MarkerSize', msize, 'LineWidth', lwidth);

legend('MCC', 'Iteration 1', 'Iteration 2', 'Iteration 3');

box on;
grid on;
titleName = sprintf('iLIDs(one click)');
title(titleName, 'fontsize', 30);
xlabel('CMC order', 'fontsize', 30); ylabel('Recognition rate', 'fontsize', 30);
xlim([1, showorder(end)]);
hold off


