% keep fixed
rand('state', 3);
close all
clrs = rand(20,3);                % ɫ
clrs = [clrs; [1,0,0]];
msize = 15;                      % marker size
lwidth = 5;                      % 

%% public parameters
NP = 632;
nfold_idx = [1:10];

%% -------------------------------------------------------------------------------------
%% combine with prid methods (one click)
showorder = [1:30];
nIter = 1;
nTopShow = 0;

% l1 + no visual expansion
matname = sprintf('./one-click/rerank_l1_%d_RF_lapSVM_bestParam_nomapped.mat', NP);
load(matname);
rerank_cf_nomapped_l1_one_click = rerank_history;

% l1 + cf
matname = sprintf('./one-click/rerank_l1_%d_RF_lapSVM_bestParam.mat', NP);
load(matname);
rerank_cf_l1_one_click = rerank_history;

% l1 + eu
matname = sprintf('./one-click/rerank_l1_%d_eu-selftune_lapSVM.mat', NP);
load(matname);
rerank_eu_l1_one_click = rerank_history;

% l1 + nomanifold
matname = sprintf('./one-click/rerank_l1_%d_nomanifold.mat', NP);
load(matname);
rerank_nomanifold_l1_one_click = rerank_history;

% lapsvm + prdc
matname = sprintf('./one-click/rerank_prdc_%d_RF_lapSVM_bestParam.mat', NP);
load(matname);
rerank_prdc_one_click = rerank_history;

% lapsvm + ranksvm
matname = sprintf('./one-click/rerank_ranksvm_%d_RF_lapSVM_bestParam.mat', NP);
load(matname);
rerank_ranksvm_one_click  = rerank_history;

% lapsvm + mcc
matname = sprintf('./one-click/rerank_mcc_%d_RF_lapSVM_bestParam.mat', NP);
load(matname);
rerank_mcc_one_click  = rerank_history;

% other methods

% naive
matname = sprintf('./one-click/rerank_naive_l1_%d_one_click.mat', NP);
load(matname);
rerank_naive_l1_one_click  = rerank_naive;

% NPRF
matname = sprintf('./one-click/rerank_l1_%d_topbottom_nprf.mat', NP);
load(matname);
rerank_nprf_one_click  = rerank_history;

% PRF
matname = sprintf('./one-click/rerank_l1_%d_topbottom_prf.mat', NP);
load(matname);
rerank_prf_one_click  = rerank_history;

% EMR
matname = sprintf('./one-click/rerank_l1_%d_weakstrong_emr.mat', NP);
load(matname);
rerank_emr_one_click  = rerank_history;


stat_idx_l1 = cell(1, size(rerank_cf_l1_one_click, 2));
for nf = 1:size(rerank_cf_l1_one_click, 2)
    stat_idx_l1{nf} = find(rerank_cf_l1_one_click{nf}(:,1) > nTopShow);
end
cmc_cf_l1_one_click   = getCmcFromFeedback(rerank_cf_l1_one_click, nfold_idx, 316, stat_idx_l1);
% 
stat_idx_l1 = cell(1, size(rerank_naive_l1_one_click, 2));
for nf = 1:size(rerank_naive_l1_one_click, 2)
    stat_idx_l1{nf} = find(rerank_naive_l1_one_click{nf}(:,1) > nTopShow);
end
cmc_naive_l1_one_click   = getCmcFromFeedback(rerank_naive_l1_one_click, nfold_idx, NP, stat_idx_l1);
cmc_nprf_one_click   = getCmcFromFeedback(rerank_nprf_one_click, nfold_idx, NP, stat_idx_l1);
cmc_prf_one_click   = getCmcFromFeedback(rerank_prf_one_click, nfold_idx, NP, stat_idx_l1);
cmc_emr_one_click   = getCmcFromFeedback(rerank_emr_one_click, nfold_idx, NP, stat_idx_l1);
cmc_nove_l1_one_click   = getCmcFromFeedback(rerank_cf_nomapped_l1_one_click, nfold_idx, NP, stat_idx_l1);

%
stat_idx_eu = cell(1, size(rerank_eu_l1_one_click, 2));
for nf = 1:size(rerank_cf_l1_one_click, 2)
    stat_idx_eu{nf} = find(rerank_eu_l1_one_click{nf}(:,1) > nTopShow);
end
cmc_eu_l1_one_click   = getCmcFromFeedback(rerank_eu_l1_one_click, nfold_idx, 316, stat_idx_eu);

%
stat_idx_no = cell(1, size(rerank_nomanifold_l1_one_click, 2));
for nf = 1:size(rerank_nomanifold_l1_one_click, 2)
    stat_idx_no{nf} = find(rerank_nomanifold_l1_one_click{nf}(:,1) > nTopShow);
end
cmc_nomanifold_l1_one_click   = getCmcFromFeedback(rerank_nomanifold_l1_one_click, nfold_idx, 316, stat_idx_no);


% ranksvm
stat_idx_ranksvm = cell(1, size(rerank_ranksvm_one_click, 2));
for nf = 1:size(rerank_ranksvm_one_click, 2)
    stat_idx_ranksvm{nf} = find(rerank_ranksvm_one_click{nf}(:,1) > nTopShow);
end
cmc_ranksvm_one_click   = getCmcFromFeedback(rerank_ranksvm_one_click, nfold_idx, 316, stat_idx_ranksvm);

% prdc
stat_idx_prdc = cell(1, size(rerank_prdc_one_click, 2));
for nf = 1:size(rerank_prdc_one_click, 2)
    stat_idx_prdc{nf} = find(rerank_prdc_one_click{nf}(:,1) > nTopShow);
end
cmc_prdc_one_click   = getCmcFromFeedback(rerank_prdc_one_click, nfold_idx, 316, stat_idx_prdc);

% mcc
stat_idx_mcc = cell(1, size(rerank_mcc_one_click, 2));
for nf = 1:size(rerank_mcc_one_click, 2)
    stat_idx_mcc{nf} = find(rerank_mcc_one_click{nf}(:,1) > nTopShow);
end
cmc_mcc_one_click   = getCmcFromFeedback(rerank_mcc_one_click, nfold_idx, 316, stat_idx_mcc);


%% compare with other re-id methods
figure, hold on
showorder = 5;
msize = 15;                      % marker size
lwidth = 5;                      % 

plot(cmc_naive_l1_one_click(:, showorder), 'Color', clrs(1,:), 'LineStyle', '-', 'LineWidth', lwidth);
plot(cmc_nomanifold_l1_one_click(:,showorder), 'Color', clrs(6,:), 'LineStyle', '-', 'Marker', 'd', 'MarkerSize', msize, 'LineWidth', lwidth);

plot(cmc_nprf_one_click(:, showorder), 'Color', clrs(2,:), 'LineStyle', '-', 'Marker', '<', 'MarkerSize', msize,'LineWidth', lwidth);
plot(cmc_prf_one_click(:, showorder), 'Color', clrs(3,:), 'LineStyle', '-', 'Marker', '>', 'MarkerSize', msize,'LineWidth', lwidth);

plot(cmc_emr_one_click(:,showorder), 'Color', clrs(5,:), 'LineStyle', '-', 'Marker', '+', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_cf_l1_one_click(:,showorder), 'Color', clrs(end,:), 'LineStyle', '-', 'Marker', 's', 'MarkerSize', msize, 'LineWidth', lwidth);

legend('Naive', 'SVM', 'NPRF', 'PRF', 'EMR',  'POP');

box on;
grid on;
titleName = sprintf('(One-click)Matching rate in Top %d (viper)', showorder);
title(titleName, 'fontsize', 30);
xlabel('round of feedback', 'fontsize', 30); ylabel('Recognition rate', 'fontsize', 30);
xlim([1, 5]);
set(gca, 'xtick', [1 2 3 4 5]);
set(gca, 'XTickLabel', {'0','1','2','3','4'});

%% With or Without visual Expansion
figure, hold on
showorder = 5;
plot(cmc_nove_l1_one_click(:,showorder), 'Color', clrs(10,:), 'LineStyle', '-', 'Marker', 's', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_cf_l1_one_click(:,showorder), 'Color', clrs(7,:), 'LineStyle', '-', 'Marker', 'd', 'MarkerSize', msize, 'LineWidth', lwidth);

legend('Without Visual Expansion', 'With Visual Expansion');

box on;
grid on;
titleName = sprintf('(one-click)Matching rate in Top %d (viper)', showorder);
title(titleName, 'fontsize', 30);
xlabel('round of feedback', 'fontsize', 30); ylabel('Recognition rate', 'fontsize', 30);
xlim([1, 5]);
set(gca, 'xtick', [1 2 3 4 5]);
set(gca, 'XTickLabel', {'0','1','2','3','4'});

%% combine with re-id methods
% % (1) initialized by L1
showorder = [1:30];
lwidth = 3;
msize = 10;
figure, hold
plot(cmc_cf_l1_one_click(1,showorder), 'Color', clrs(1,:), 'LineStyle', '--', 'LineWidth', lwidth);
plot(cmc_cf_l1_one_click(2,showorder), 'Color', clrs(6,:), 'LineStyle', '-', 'Marker', 'o', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_cf_l1_one_click(3,showorder), 'Color', clrs(7,:), 'LineStyle', '-', 'Marker', '+', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_cf_l1_one_click(4,showorder), 'Color', clrs(8,:), 'LineStyle', '-', 'Marker', 's', 'MarkerSize', msize, 'LineWidth', lwidth);

set(gca, 'fontsize', 30);

legend('L1-Norm', 'Iteration 1', 'Iteration 2', 'Iteration 3', 'fontsize', 24);
box on;
grid on;
titleName = sprintf('viper(one click)');
title(titleName, 'fontsize', 30);
xlabel('CMC order', 'fontsize', 30); ylabel('Recognition rate', 'fontsize', 30);
xlim([1, showorder(end)]);
ylim([0, 1]);
set(gca,'ytick', [0 0.2 0.4 0.6 0.8 1.0]);

% (2) initialized by ranksvm
figure, hold
plot(cmc_ranksvm_one_click(1,showorder), 'Color', clrs(1,:), 'LineStyle', '--', 'LineWidth', lwidth);
plot(cmc_ranksvm_one_click(2,showorder), 'Color', clrs(6,:), 'LineStyle', '-', 'Marker', 'o', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_ranksvm_one_click(3,showorder), 'Color', clrs(7,:), 'LineStyle', '-', 'Marker', '+', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_ranksvm_one_click(4,showorder), 'Color', clrs(8,:), 'LineStyle', '-', 'Marker', 's', 'MarkerSize', msize, 'LineWidth', lwidth);

legend('RankSVM', 'Iteration 1', 'Iteration 2', 'Iteration 3');

box on;
grid on;
titleName = sprintf('viper(one click)');
title(titleName, 'fontsize', 30);
xlabel('CMC order', 'fontsize', 30); ylabel('Recognition rate', 'fontsize', 30);
xlim([1, showorder(end)]);
ylim([0, 1]);
set(gca,'ytick', [0 0.2 0.4 0.6 0.8 1.0]);
hold off

% % (3) initialized by prdc
figure, hold
plot(cmc_prdc_one_click(1,showorder), 'Color', clrs(1,:), 'LineStyle', '--', 'LineWidth', lwidth);
plot(cmc_prdc_one_click(2,showorder), 'Color', clrs(6,:), 'LineStyle', '-', 'Marker', 'o', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_prdc_one_click(3,showorder), 'Color', clrs(7,:), 'LineStyle', '-', 'Marker', '+', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_prdc_one_click(4,showorder), 'Color', clrs(8,:), 'LineStyle', '-', 'Marker', 's', 'MarkerSize', msize, 'LineWidth', lwidth);

legend('PRDC', 'Iteration 1', 'Iteration 2', 'Iteration 3');

box on;
grid on;
titleName = sprintf('viper(one click)');
title(titleName, 'fontsize', 30);
xlabel('CMC order', 'fontsize', 30); ylabel('Recognition rate', 'fontsize', 30);
xlim([1, showorder(end)]);
ylim([0, 1]);
set(gca,'ytick', [0 0.2 0.4 0.6 0.8 1.0]);
hold off

% % (3) initialized by mcc
figure, hold
plot(cmc_mcc_one_click(1,showorder), 'Color', clrs(1,:), 'LineStyle', '--', 'LineWidth', lwidth);
plot(cmc_mcc_one_click(2,showorder), 'Color', clrs(6,:), 'LineStyle', '-', 'Marker', 'o', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_mcc_one_click(3,showorder), 'Color', clrs(7,:), 'LineStyle', '-', 'Marker', '+', 'MarkerSize', msize, 'LineWidth', lwidth);
plot(cmc_mcc_one_click(4,showorder), 'Color', clrs(8,:), 'LineStyle', '-', 'Marker', 's', 'MarkerSize', msize, 'LineWidth', lwidth);

legend('MCC', 'Iteration 1', 'Iteration 2', 'Iteration 3');

box on;
grid on;
titleName = sprintf('viper(one click)');
title(titleName, 'fontsize', 30);
xlabel('CMC order', 'fontsize', 30); ylabel('Recognition rate', 'fontsize', 30);
xlim([1, showorder(end)]);
ylim([0, 1]);
set(gca,'ytick', [0 0.2 0.4 0.6 0.8 1.0]);
hold off


